//dashLicious - a widget by protagonist (ben jennings)  2006

//VARIABLES
var req; //xhr object var
var browserInput = 1; //whether on browers or nnw
var bSelect = 1; //default browser value
var browserLookup = new Array('nnw', 'safari', 'firefox', 'camino', 'omniweb', 'webkit', 'chrome');
var tagLookupDone = 0;
var gDoneButton;
var gSubmitButton;
var gInfoButton;
var checkedState = 0;

// var ac = new autocomplete();

//HIDE AND SEEK
if (window.widget) {
    widget.onhide = onhide;
    widget.onshow = onshow;
}

//sets up the interface buttons, loads the preferences, calls the tags and kicks off
function setup() {
    progInd = new ProgressIndicator(document.getElementById('progressGraphic'), "images/prog");
    gDoneButton = new AppleGlassButton(document.getElementById("doneButton"), "Done", hidePrefs);
    gSubmitButton = new AppleGlassButton(document.getElementById("submitButton"), "submit", delPost);
    gInfoButton = new AppleInfoButton(document.getElementById("infoButton"), document.getElementById("front"), "white", "white", showPrefs);

    if (window.widget) {
        var temp1 = widget.preferenceForKey('username');
        var temp2 = widget.preferenceForKey('password');
        
        if (temp1 == undefined || temp1 == "") { // if no preferences set
            document.getElementById('username').value = "";
            document.getElementById('password').value = ""; 
            widget.setPreferenceForKey(bSelect, 'bSelect');
        } else { // otherwise, load prefs
            document.getElementById('username').value = temp1;
            document.getElementById('password').value = temp2;
            bSelect = widget.preferenceForKey('bSelect');
            if (bSelect == undefined) {
                //alert('catch called');
                bSelect = 1;
                widget.setPreferenceForKey(bSelect, 'bSelect');
            }
            if (tagLookupDone == 0) {
                autoTag();//setup();
                tagLookupDone = 1;
            }
        }
    }
    onshow();
}

function onshow() {
    grabData();
    //nnwTrigger(); //this is waiting on nnw support
    //userFeedback('sending post...', 'feedback');
}

function nnwTrigger() { //waiting on nnw support
    var nnwCheck = escape(widget.system("/bin/cat ~/.dashLicious", null).outputString);
    nnwCheck = nnwCheck.substring(0,4);
    widget.system("/bin/rm ~/.dashLicious", null);
    if (nnwCheck == "true") {
        browserInput = 0;
        bSelect = 0;        
        //alert("nnwTrigger true: " + nnwCheck);
    } else {
        //alert("nnwTrigger false");
    }
    grabData();
}

//resets the comment and tag fields
function onhide() {
    document.getElementById('extended').value = '';
    document.getElementById('tags').value = '';
    userFeedback('', 'feedback');
    document.getElementById("counterInfo").innerHTML = "(255/255)";
}

//give userfeedback to either the feedback field or the browers selection field
//@param input  text to display
//@param loc:   currently either feedback or bIdent
function userFeedback (input, loc) {
    // alert("input: " + input + " loc: " + loc);
    var status = document.getElementById(loc);
    var node = document.createTextNode(input);

    if (status.firstChild) {
        status.replaceChild(node, status.firstChild);
    } else {
        status.appendChild(node);
    }
}

//switches between default browser and netnewswire
function switchData() {
    if (browserInput == 0) { //switching from nnw to browser
        browserInput = 1;
        bSelect = widget.preferenceForKey('bSelect');
    } else { //switching from browser to nnw
        browserInput = 0;
        bSelect = 0;
    }
    var temp = 'switching to ' + browserLookup[bSelect];
    userFeedback(temp, 'feedback');
    grabData();
}

//form validation
function testUser() {
    if (document.getElementById('username').value == "") {
        userFeedback('no username', 'feedback');
        return 0;
    } else if (document.getElementById('password').value == "") {
        userFeedback('no password', 'feedback');
        return 0;
    } else {
        return 1;
    }
}

function grabData() {
    // console.log("grabData called...");
    // console.log("bselect:" + bSelect)

    var select;
    switch(bSelect) {
        case 0:
            var select = "scripts/nnw.scpt";
            break;
        case 1:
            var select = "scripts/safari.scpt";
            break;
        case 2:
            var select = "scripts/firefox.scpt";
            break;
        case 3:
            var select = "scripts/camino.scpt";
            break;
        case 4:
            var select = "scripts/omni.scpt";
        case 5:
            var select = "scripts/webkit.scpt";
        case 6:
            var select = "scripts/chrome.scpt";

    }

    var obj = widget.system("/usr/bin/osascript " + select, activateData);
    userFeedback(browserLookup[bSelect], 'bIdent');
    userFeedback('', 'feedback');
}

function activateData(input) {
    // console.log("activateData called...");
    var storage = input.outputString;
    if (input.status == 0) {
        if (storage == 0) { //app is not running or doesn't exist
            // console.log("not running...");
            userFeedback('not running', 'feedback');
            document.getElementById('url').value = "";
            document.getElementById('description').value = "";
            userFeedback('browser not running', 'feedback');
        } else if (storage == 2) { //is running but isn't showing anything
            // console.log("isn't showing anything");
            document.getElementById('url').value = "";
            document.getElementById('description').value = "";
            userFeedback('no page open', 'feedback');
        } else if (storage == 1) {
            // console.log("no window open");
            document.getElementById('url').value = "";
            document.getElementById('description').value = "";
            userFeedback('no window open', 'feedback');
        } else { //is running - grab the information
            // console.log("running grab the information");
            var test = storage.split("||");
            document.getElementById('url').value = test[0];
            document.getElementById('description').value = test[1];
        }
    }
}

function delPost() {
    window.document.getElementById('tags').blur();
    var test = testUser();
    if (test == 1) {

        if (browserInput == 0) {
            //alert('posting from nnw');
            widget.system("/usr/bin/osascript scripts/nnwAttention.scpt", null);
        } else {
            //alert('browserInput status:' + browserInput);
        }
        
        progInd.start();
        userFeedback('sending post...', 'feedback');
        var currentTime = new Date()
        var day = currentTime.getDate()
        var month = currentTime.getMonth()
        var year = currentTime.getFullYear()        
        var hour = currentTime.getHours()
        var minute = currentTime.getMinutes()
        var second = currentTime.getSeconds()
        
        var username = window.document.getElementById('username').value;
        var password = window.document.getElementById('password').value;
        var url = "&url=" + window.document.getElementById('url').value;
        var description = "&description=" + encodeURIComponent(window.document.getElementById('description').value);
        var extended = "&extended=" + encodeURIComponent(window.document.getElementById('extended').value);
        var tags = "&tags=" + encodeURIComponent(window.document.getElementById('tags').value);
        var dt = "&dt=" + year + "-" + (month + 1) + "-" + day + "T" + hour + ":" + minute + ":" + second + "Z";
        var prefix1 = "https://";
        var prefix2 = "api.del.icio.us/v1/posts/add?noui=yes";
        var postfix = "";
        var shared;

        if (checkedState == 0) {
            shared = "&shared=yes";
        } else {
            shared = "&shared=no";
        }

        var output = prefix1 + username + ":" + password + "@" + prefix2 + url + description + extended + tags + dt + shared + postfix;
        
        //alert("final: " + output);
        
        req = new XMLHttpRequest();
        req.onreadystatechange = processReqChange;
        req.open("GET", output, true);
        req.send(null);
        
        checkedState = 1;
        privacySwitch();
    }
}

function processReqChange() { //error code
    if (req.readyState == 4) {
        if (req.status == 200) {
                userFeedback('status: 200', 'feedback');
        } 
            if (req.status == 503) {
                userFeedback('status: 203', 'feedback');
            } 
            if (req.status == 500) {
                userFeedback('status: 500', 'feedback');
            }
            else {
                userFeedback('del.icio.us post sent', 'feedback');
                progInd.stop();
                tagCheck();
                window.document.getElementById('url').value = "";
                window.document.getElementById('description').value = "";
                window.document.getElementById('extended').value = "";
                window.document.getElementById('tags').value = "";
                document.getElementById("counterInfo").innerHTML = "(255/255)";
        }
    }
}

//pref saving code
function savePrefs(){
    if (window.widget) {
        var input1 = document.getElementById('username').value;
        widget.setPreferenceForKey(input1, 'username');
        var input2 = document.getElementById('password').value;
        widget.setPreferenceForKey(input2, 'password');
        
        //var input3 = parseInt(select.options[select.selectedIndex].value);
        //alert("here:" + window.document['select_browser'].selectedIndex);
        
        //var input3 = document.getElementById('select').value;
        //widget.setPreferenceForKey(input3, 'bSelect');
    }   
}

//saves the default browser choice
function saveBrowser(input) {
    var input3 = parseInt(input.options[input.selectedIndex].value);
    bSelect = input3;
    widget.setPreferenceForKey(input3, 'bSelect');
    grabData();//as browser has been changed, update input
    browserInput = 1;
}

//TAGS CODE
var tag = 'foo bar test1 test2';
var tagStore = tag.split(" ");
tagStore.sort();


//SWITCH CODE
function enterswitch(event) {
    document.getElementById('underswitch').style.display = 'block';
}

function exitswitch(event) {
    document.getElementById('underswitch').style.display = 'none';
}

//APPLECLASSES CODE

function showPrefs() {
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget)
        widget.prepareForTransition("ToBack");

    front.style.display="none";     // hide the front
    back.style.display="block";     // show the back

    if (window.widget)
        setTimeout ('widget.performTransition();', 0);      // and flip the widget over 


    //document.getElementById('fliprollie').style.display = 'none'; //this is redundant  
}

function hidePrefs() {
    //protagonist extra bit
    savePrefs();
    autoTag();
    //setup(); //to recall tags incase the user was switched
    //end extra bit

    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget)
        widget.prepareForTransition("ToFront");

    back.style.display="none";          // hide the back
    front.style.display="block";        // show the front

    if (window.widget)
        setTimeout ('widget.performTransition();', 0);
}

function showBack() {
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget)
        widget.prepareForTransition("ToBack");

    front.style.display="none";
    back.style.display="block";
 
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);  
}

function hideBack() {
    var front = document.getElementById("front");
    var back = document.getElementById("back");
 
    if (window.widget)
        widget.prepareForTransition("ToFront");
 
    back.style.display="none";
    front.style.display="block";
 
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);
}

//KEYBOARD CONTROLS (v1.4)
document.onkeydown = KeyCheck;

function KeyCheck(e) {
    var KeyID = String.fromCharCode(e.which);       
    if (e.ctrlKey == true) {
        switch (KeyID) {
            case "S":
                //alert("cntrl and S pressed"); //save post
                delPost();
                break;
            case "T":
                //alert("cntrl and T pressed"); //switch input
                switchData();
                break;  
            case "L":
                //alert("cntrl and L pressed"); //switch privacy
                privacySwitch();
                break;
        }
    }
}

//COUNTER FOR MAX NUM (v1.4)
function textCounter() {
    field = document.getElementById("extended");
    maxlimit = 255;
    if (field.value.length > maxlimit) {
        field.value = field.value.substring(0, maxlimit);
        field.setSelectionRange(255, 255);
    } else {
        //cntfield.value = maxlimit - field.value.length;
        numLeft = maxlimit - field.value.length;
        document.getElementById("counterInfo").innerHTML = "(" + numLeft + "/255)";
    }
}

//PRIVACY (v1.4)
function privacySwitch() {
    //document.getElementById('floater').style.display = 'none';
    if (checkedState == 0) {
        document.getElementById('checkImage').src = 'images/checked.png';
        checkedState = 1;
    } else {
        document.getElementById('checkImage').src = 'images/unchecked.png';
        checkedState = 0;
    }
}